#include <bits/stdc++.h>

using namespace std;
const int N = 11e4;
set<int> z[N];
int x[N];

int main()
{
    ios_base::sync_with_stdio(false);
    int w, h, r, q; cin >> w >> h >> r >> q;
    for(int i=0;i<=w;i++) x[i]=h;
    while(q--) {
        int p, xi, yi;
        cin >> p;
        if(p==2) cin >> xi, cout << x[xi] << endl;
        else {
            cin >> xi >> yi;
            if((z[xi].count(yi-1)&&z[xi].count(yi+1)) || z[xi].count(yi)) x[xi]=x[xi];
            else if((z[xi].count(yi-1)&&yi>0) || (z[xi].count(yi+1)&&yi<w) || yi==w || yi==0) x[xi]--;
            else x[xi]-=2;
            z[xi].emplace(yi);
        }
    }
    return 0;
}